import java.util.*;

/**
 * Skeleton of a deterministic Turing Machine (TM) with a single, left-bounded tape
 */
public class TuringMachine {
	// Integer constants for head movements
	public static final int HOLD = 0, LEFT = 1, RIGHT = 2;
	
	// Tabular representation of deterministic transition matrix
	private TMResult[][] transitionMatrix;
	private TMTape tape;
	...
	
	// Create a new instance for a TM with maximal number of states and symbols
	public TuringMachine(int maxStates, int maxSymbols) {
	...
	}
	
	// Retrieve tape for preparing of input
	public TMTape getTape() {
		return tape;
	}

	// Add a new state to the TM if it does not already exist
	public TMState addState(String name, boolean isStart) {
	...
	}
	
	// Add a new symbol to the TM if it does not already exist
	public TMSymbol addSymbol(String symbol) {
	...
	}
		
	// Add a new transition to the TM (all referenced states & symbols have to exist already)
	public void addTransition(String fromState, String inputSymbol, 
				  String toState, String outputSymbol, int headDirection) {
	...
	}
	
	// Initialize TM with start state and given position on the tape
	public void init(int pos) {
	...
	}
	
	// Execute TM after previous initialisation, providing trace output of current state,
	// position and tape content if desired
	public void execute(boolean doTrace) {
	...
	}
}
